<script setup>
// ----------------------------------------------------------------
// Imports
// ----------------------------------------------------------------
import { useWebsocketStore } from "@/stores/useWebsocketStore";
import { useI18n } from "vue-i18n";
import { useDisplay, useTheme } from "vuetify";

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------
const websocketStore = useWebsocketStore();

const t = useI18n();
const theme = useTheme();

const config = useRuntimeConfig();
const appID = config.public.oidcClientID;

const { mobile } = useDisplay();
const drawer = ref(false);

const season = computed(() => {
  if (new Date().getMonth() === 3) {
    return "easter";
  } else if (new Date().getMonth() === 11) {
    return "christmas";
  }
  return "default";
});

const showScrollButton = ref(false);
const scrollTarget = ref(null);

const dialogError = true;

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------
function handleScroll() {
  if (scrollTarget.value) {
    showScrollButton.value = scrollTarget.value.$el.scrollTop > 300;
  }
}

function scrollToTop() {
  if (scrollTarget.value) {
    scrollTarget.value.$el.scrollTo({ top: 0, behavior: "smooth" });
  }
}

function recoverFromError(error) {
  // Try to resolve the error here
  error.value = null;
}

function filterError(errorMessage) {
  const regex = /^schema with key or id "https?:\/\/[^\s"]+" already exists$/;
  return regex.test(errorMessage);
}

function ErrorLogger(err) {
  if (!filterError(err.message)) {
    console.error(err);
  }
}

async function copyToClipboard(error) {
  await navigator.clipboard.writeText(error.value);
}

function onDrawerStateChange(newValue) {
  drawer.value = newValue;
}

// ----------------------------------------------------------------
// Main
// ----------------------------------------------------------------

useAPIFetch(`/api/applications/${appID}/userparams`).then((response) => {
  // Theme
  if ("params" in response.data.value && "theme" in response.data.value.params) {
    theme.global.name.value = response.data.value.params.theme;
  }

  // Language
  if ("params" in response.data.value && "language" in response.data.value.params) {
    t.locale.value = response.data.value.params.language;
  }
});

// Initialize WebSocket connections for "workspaces/" and "notifications/"
websocketStore.initWebSocket("workspaces/").catch((error) => {
  console.error(error);
});

websocketStore.initWebSocket("notifications/").catch((error) => {
  console.error(error);
});

// ----------------------------------------------------------------
// Lifecycle
// ----------------------------------------------------------------
onMounted(() => {
  drawer.value = !mobile.value;
  nextTick(() => {
    if (scrollTarget.value) {
      scrollTarget.value.$el.addEventListener("scroll", handleScroll);
    }
  });
});

onUnmounted(() => {
  if (scrollTarget.value) {
    scrollTarget.value.$el.removeEventListener("scroll", handleScroll);
  }
});
</script>

<template>
  <v-layout class="rounded rounded-md">
    <v-app class="overflow-y-hidden" full-height>
      <v-navigation-drawer
        :width="340"
        :model-value="drawer"
        @update:modelValue="onDrawerStateChange"
      >
        <template v-slot:prepend>
          <div class="d-flex">
            <template v-if="season === 'easter'">
              <div class="ps-5 me-auto align-self-center">
                <img
                  src="/img/name_easter.svg"
                  alt="MADBOT"
                  height="30"
                  width="auto"
                >
              </div>
            </template>
            <template v-else-if="season === 'christmas'">
              <div class="ps-5 me-auto align-self-center">
                <img
                  src="/img/name_christmas.svg"
                  alt="MADBOT"
                  height="30"
                  width="auto"
                >
              </div>
            </template>
            <template v-else>
              <p class="ps-5 me-auto align-self-center" style="font-family: Futura; font-size: 20px;">
                <b><span style="color: #115c99;">MAD</span><span style="color: #249fd6;">BOT</span></b>
              </p>
            </template>
            <v-btn
              variant="plain"
              icon="mdi-menu-open"
              size="small"
              fixed
              slim
              @click="drawer = !drawer"
            />
          </div>

          <div class="px-5 py-0">
            <WorkspaceMenu />
            <Dashboard />
            <NotificationsMenu />
            <Parameters />
            <SubmissionMenu />
            <NodeNew />
          </div>
        </template>

        <NodeMenu class="pa-5" />
        <template v-slot:append>
          <div class="px-5 py-3 ">
            <UserBar />
          </div>
        </template>
      </v-navigation-drawer>
      <v-navigation-drawer
        v-if="mobile || drawer === false"
        class="remove-border mt-1"
        location="left"
        width="35"
        permanent
      >
        <v-btn
          variant="plain"
          icon="mdi-menu"
          size="small"
          fixed
          slim
          @click="drawer = !drawer"
        />
      </v-navigation-drawer>
      <NuxtErrorBoundary @error="ErrorLogger">
        <v-main ref="scrollTarget" style="max-height: calc(100vh - 10px); overflow-y: auto">
          <Toaster position="top-right" />
          <slot />

          <v-fab
            v-show="showScrollButton"
            color="primary"
            elevation="8"
            icon="mdi-chevron-up"
            size="36px"
            class="scroll-to-top"
            @click="scrollToTop"
          />
          <FloatingBtn />
          <CookieControl :locale="t.locale.value" />
        </v-main>
        <template #error="{ error }">
          <v-main style="max-height: calc(100vh - 10px); overflow-y: auto">
            <Toaster position="top-right" />
            <slot />
            <FloatingBtn />
            <v-dialog
              v-if="!filterError(error.value.message)"
              v-model="dialogError"
              persistent
              width="auto"
            >
              <v-card>
                <v-card-title style="color: darkred">
                  <h2>
                    <v-icon size="40px">
                      mdi-close-circle
                    </v-icon>
                    <span>
                      <template v-if="error.value.statusCode">Madbot has encountered an error</template>
                      <template v-else>Madbot has encountered an unexpected error</template>
                    </span>
                    <span v-if="error.value.data?.type">: {{ error.value.data.type }} </span>
                  </h2>
                </v-card-title>
                <v-card-text>
                  <p v-if="error.value.data?.message">
                    {{ error.value.data.message }}
                  </p>
                  <div v-else>
                    <p>Contact the instance administrator with the error below</p>

                    <v-code class="mt-2" @click="copyToClipboard(error)">
                      {{ error.value }}
                    </v-code>
                  </div>

                  <div v-if="error.value.data?.details">
                    <p class="mt-4">
                      <b>Details</b>
                    </p>
                    <v-list>
                      <v-list-item
                        v-for="(item, index) in error.value.data.details"
                        :key="index"
                        class="px-0"
                      >
                        <v-list-item-title>
                          <span>{{ item.parameter }}</span>
                        </v-list-item-title>
                        <v-list-item-subtitle>{{ item.message }}</v-list-item-subtitle>
                      </v-list-item>
                    </v-list>
                  </div>
                </v-card-text>
                <v-card-actions>
                  <v-btn
                    block
                    color="primary"
                    @click="recoverFromError(error)"
                  >
                    Close
                  </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
            <CookieControl :locale="t.locale.value" />
          </v-main>
        </template>
      </NuxtErrorBoundary>
    </v-app>
  </v-layout>
</template>

<style>
.madbot-sidebar {
  background-color: rgb(var(--v-theme-background-gray));
}

html {
  overflow: hidden;
  /* Hide scrollbars */
}

.v-navigation-drawer >>> .v-navigation-drawer__border {
  display: none;
}

.remove-border {
  border-right-width: 0 !important;
}

.scroll-to-top {
  position: fixed;
  bottom: 75px;
  right: 52px;
  z-index: 1100;
}
</style>
